{% extends "dashboard/dashboard_content.html" %}

{% block title %}
    Create TimeTable
{% endblock %}

{% block rightPane %}
    {% if perms.curriculum.can_create_timetable %}
        <div class="x_panel">
            <div class="x_title">
                <h2>
                    <i class="fa fa-calendar-plus-o"></i>
                    Create Timetable
                </h2>
                <div class="clearfix"></div>
            </div>
            <div class="x_content">
                <div class="row">
                    <ul class="nav nav-tabs bar_tabs">
                        {% for semester in list_of_semesters %}
                            {% if forloop.counter == 1 %}
                                <li {% if selected_semester == semester.semester_instance.pk %}class="active" {% else %}
                                    class="" {% endif %} onmouseover="$(this).css('cursor','pointer');">
                                    <a aria-expanded="true"
                                       id={{ semester.semester_instance.pk }}
                                               data-toggle="tab" name="batch_tab">
                                        {{ semester.display_text }}

                                    </a>
                                </li>
                            {% else %}
                                <li {% if selected_semester == semester.semester_instance.pk %}class="active" {% else %}
                                    class="" {% endif %} onmouseover="$(this).css('cursor','pointer');">
                                    <a aria-expanded="true"
                                       id={{ semester.semester_instance.pk }}
                                               data-toggle="tab" name="batch_tab">
                                        {{ semester.display_text }}
                                    </a>
                                </li>
                            {% endif %}
                        {% endfor %}
                    </ul>
                    <br>
                    <br>
                    <div class="tab-content">
                        {% if no_faculty_advisor %}
                            <div role="alert" class="alert alert-warning alert-dismissible fade in">
                                <h5> Allot Faculty Advisor to the batch in order to create timetable </h5>
                            </div>
                        {% elif no_start_date %}
                            <div role="alert" class="alert alert-warning alert-dismissible fade in">
                                <h5> Set Term 1 start date to the batch in order to create timetable </h5>
                            </div>
                        {% elif no_of_courses == 0 %}
                            <div role="alert" class="alert alert-info alert-dismissible fade in">
                                <h5> Currently No Courses are available </h5>
                            </div>
                        {% else %}
                            <ul class="nav navbar-right panel_toolbox">
                                <li>
                                    <button id="revision" class="btn1 btn1-secondary">Timetable Revision</button>
                                </li>
                            </ul>
                            <div class="alert alert-success" role="alert" align="center">
                                <h5> Current Faculty Advisors:&nbsp;
                                    <strong>
                                        {% for faculty in faculty_advisors %}
                                            {{ faculty }}&nbsp;&nbsp;
                                        {% endfor %}
                                    </strong>
                                </h5>
                            </div>
                            <div class="table-responsive">
                                <table class="table table-bordered col-md-12 col-sm-12 col-xs-12">
                                    <thead>
                                    <tr>
                                        <th>#</th>
                                        <th>1st hour</th>
                                        <th>2nd hour</th>
                                        <th>3rd hour</th>
                                        <th>4th hour</th>
                                        <th>5th hour</th>
                                        <th>6th hour</th>
                                        <th>7th hour</th>
                                        <th>8th hour</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    {% for day in list_of_hours %}
                                        <tr>
                                            <th>{{ day.day_name }}</th>
                                            {% for hour in day.hours %}
                                                <td data-toggle="modal" data-target="#data"
                                                    align="center" onmouseover="this.bgColor='#41c8ff'"
                                                    onmouseout="this.bgColor='white'">
                                                    {% if not hour %}
                                                        -
                                                    {% else %}
                                                        {% for course in hour %}
                                                            {{ course }}<br>
                                                        {% endfor %}
                                                    {% endif %}
                                                </td>
                                            {% endfor %}
                                        </tr>
                                    {% endfor %}
                                    </tbody>
                                </table>
                            </div>
                            <br><br>
                            <table class="table table-hover">
                                <thead>
                                <tr>
                                    <th>Course Code</th>
                                    <th>Course Name</th>
                                    <th>Staff Handling</th>
                                </tr>
                                </thead>
                                <tbody>
                                {% for course in list_of_courses %}
                                    {% if not course.common %}
                                        <tr>
                                            <td>{{ course.course_id }}</td>
                                            <td>
                                                {{ course.course_name }}&nbsp;
                                                {% if course.code %}
                                                    ({{ course.code }})
                                                {% endif %}&nbsp;
                                                {{ course.course_type }}
                                            </td>
                                            <td>
                                                {% for staff in course.staff_list %}
                                                    {{ staff }}&nbsp;&nbsp;
                                                {% endfor %}
                                            </td>
                                        </tr>
                                    {% endif %}
                                {% endfor %}
                                </tbody>
                            </table>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    {% endif %}
    <div class="modal" id="data" tabindex="-1" role="dialog" aria-labelledby="my" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title" id="my"> Select Operation </h4>
                </div>
                <div class="modal-body" align="center">
                    <h4 id="alert_content_data"></h4>
                    <button type="button" id="add" class="btn1 btn-dark-green">Add Course</button>
                    <button type="button" id="remove" class="btn1 btn-deep-orange">Remove Course</button>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn1 btn-cyan" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal" id="data_modal" tabindex="-1" role="dialog" aria-labelledby="my1" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title" id="mytitle"></h4>
                </div>
                <div class="modal-body">
                    <div id="data_content">
                        <div class="form-group">
                            <select id="selected_course" name="selected_course" class="form-control">
                                {% for course in list_of_courses %}
                                    <option value="{{ course.pk }}">{{ course.course_text }}&nbsp;
                                        {{ course.course_type }}</option>
                                {% endfor %}
                            </select>
                        </div>
                        <br>
                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Effect from Date
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <input id="datepicker" class="form-control" type="text" readonly
                                       value="{{ date_today|date:'d/m/Y' }}" required>
                            </div>
                        </div>
                    </div>
                    <br>
                    <br>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn1 btn-cyan" data-dismiss="modal">Close</button>
                    <button type="button" class="btn1 btn-dark-green" data-dismiss="modal" id="confirm_period">
                        Confirm Submission
                    </button>
                </div>
            </div>
        </div>
    </div>

    <form id="dummy_form" method="post">
        {% csrf_token %}
    </form>

    <form id="dummy_form_tab" method="post">
        {% csrf_token %}
    </form>

    <script type="text/javascript">
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }
        $('document').ready(function () {
            $('[name="batch_tab"]').click(function () {

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('#dummy_form_tab');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'selected_semester_tab'});
                $hiddenInput.appendTo('#dummy_form_tab');

                $('#dummy_form_tab').submit();

            });
        });
    </script>

    <script type="text/javascript">

        $(function () {
            $("#datepicker").datepicker({dateFormat: 'dd/mm/yy', beforeShowDay: $.datepicker.noWeekends});
        });


        var selected_hour, selected_day;
        $('td').click(function () {
            selected_hour = $(this).parent().children().index($(this));
            //alert(selected_hour);
            selected_day = $(this).closest('tr').children('th').text();
            //alert(selected_day);
            document.getElementById('alert_content_data').innerHTML = 'Select an operation for hour <strong>' + selected_hour + '</strong> on <strong>' + selected_day + '</strong>';
        });

        $("#confirm_period").click(function () {
            $('#data').modal('hide');
            course = $('#selected_course').val();

            if (course == null) {
                alert('No Courses selected');
                return;
            }

            var csrftoken = getCookie('csrftoken');
            var $hiddenInput = $('<input/>', {type: 'hidden', value: csrftoken, name: 'csrfmiddlewaretoken'});
            $hiddenInput.appendTo('#dummy_form');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: '{{ selected_semester }}',
                name: 'selected_semester'
            });
            $hiddenInput.appendTo('#dummy_form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#datepicker').val(), name: 'selected_date'});
            $hiddenInput.appendTo('#dummy_form');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: $('#selected_course').val(),
                name: 'selected_course'
            });
            $hiddenInput.appendTo('#dummy_form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: selected_hour, name: 'selected_hour'});
            $hiddenInput.appendTo('#dummy_form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: selected_day, name: 'selected_day'});
            $hiddenInput.appendTo('#dummy_form');

            $('#dummy_form').submit();
        });


        $(document).on("click", '#add', function (e) {

            $('#data').modal('hide');
            $.ajax({
                type: "POST",
                data: {
                    'selected_hour': selected_hour,
                    'selected_day': selected_day,
                    'add_course': 'true',
                    'selected_semester': '{{ selected_semester }}',
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'create_timetable' %}',
                success: function (data) {
                    document.getElementById('mytitle').innerHTML = 'Add Hour Confirmation';
                    $('#data').modal('show');
                    $('#data_modal').modal('show');
                    $('#data_content').show();
                    $('#selected_course').empty();
                    $.each(data.list, function (key, val) {
                        if (val.course_type) {
                            $('#selected_course').append('<option value="' + val.pk + '">' + val.course_text + '&nbsp' + val.course_type + '</option>');
                        }
                        else {
                            $('#selected_course').append('<option value="' + val.pk + '">' + val.course_text + '</option>');
                        }
                    })
                }
            });
        });

        $(document).on("click", '#remove', function (e) {

            $('#data').modal('hide');
            $.ajax({
                type: "POST",
                data: {
                    'selected_hour': selected_hour,
                    'selected_day': selected_day,
                    'remove_course': 'true',
                    'selected_semester': '{{ selected_semester }}',
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'create_timetable' %}',
                success: function (data) {
                    document.getElementById('mytitle').innerHTML = 'Remove Hour Confirmation';
                    $('#data').modal('show');
                    $('#data_modal').modal('show');
                    $('#data_content').show();
                    $('#selected_course').empty();
                    $.each(data.list, function (key, val) {
                        if (val.course_type) {
                            $('#selected_course').append('<option value="' + val.pk + '">' + val.course_text + '&nbsp' + val.course_type + '</option>');
                        }
                        else {
                            $('#selected_course').append('<option value="' + val.pk + '">' + val.course_text + '</option>');
                        }
                    })
                }
            });
        });

        {% if date_fails_start_date == True %}
            $(function () {
                new PNotify({
                    title: 'Oh Snap!',
                    text: 'Effect from date should be greater than the term 1 start date',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}

        {% if date_fails_end_date == True %}
            $(function () {
                new PNotify({
                    title: 'Oh Snap!',
                    text: 'Effect from date should be greater than the created date!',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}

        {% if duplicate_date == True %}
            $(function () {
                new PNotify({
                    title: 'Oh Snap!',
                    text: 'Course period overlaps in this date range!\nCheck Timetable Revision for more details..',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}

        $('document').ready(function () {
            $('#revision').click(function () {
                window.open('{% url 'timetable_revision' semester_pk=selected_semester %}','_self');
            });
        });

    </script>

{% endblock %}